#ifndef _BERC_DEVICE_H
#define __BERC_DEVICE_H

#include <add-ons/input_server/InputServerDevice.h>
#include <InterfaceDefs.h>
#include <SupportDefs.h>
#include <List.h>
#include <OS.h>

#include "rckeymap.h"
#include "BercPortQueue.h"

extern "C" _EXPORT BInputServerDevice* instantiate_input_device();

class BercDevice : public BInputServerDevice
{
   public:
      BercDevice();
      virtual           ~BercDevice();
      virtual status_t  InitCheck();
      virtual status_t  Start(const char *device, void *);
      virtual status_t  Stop(const char *, void *);
      virtual status_t  Control(const char *name, void *cookie,
                              uint32 command, BMessage *message);
      int32 Thread(void);
      
   private:      
      int32 SendKeyMessage(char *sz_Keyname);
      TS_RC_keymap *BercDevice::GetKeyMessageParams(char *sz_Keyname);

      volatile bool  b_Quit;     //thead control flag
      thread_id      threadid;   //thread ID

      key_map        *system_keymap;
      char           *system_char;
      TS_RC_keymap   *rc_keymap;

      BercPortQueue  *pc_PortQueue;
};

#endif 
