#ifndef RCDEFS_H
#define RCDEFS_H

/*********************************
 *    Device control Messages    *
 *********************************/
#define RC_REGISTER_CLIENT    100
#define RC_UNREGISTER_CLIENT  101

/***************************
 *    Keycodes classes     *
 ***************************/
#define RC_KEY_MAPPED   1
#define RC_KEY_UNMAPPED 2
#define RC_KEY_SYSTEM   4
#define RC_KEY_CUSTOM   8

/*******************************
 *    RC Port definitions      *
 *******************************/
#define RC_PORT_HEADER_CODE    'Bhdr'
#define RC_PORT_MESSAGE_CODE   'BMsg'

/******************************
 *    Keycodes definition     *
 ******************************/
#define RC_UNMAPPED_KEY_BASE        0x00000000

/* this is xxx custom messages  */
#define RC_UNMAPPED_KEY_CUSTOM      0x10000000
#define RC_UNMAPPED_KEY_CUSTOM_MASK 0x0000FFFF

#define RC_KEY_A              (RC_UNMAPPED_KEY_BASE | 0x00000000)
#define RC_KEY_B              (RC_UNMAPPED_KEY_BASE | 0x00000001)
#define RC_KEY_C              (RC_UNMAPPED_KEY_BASE | 0x00000002)
#define RC_KEY_D              (RC_UNMAPPED_KEY_BASE | 0x00000003)
#define RC_KEY_E              (RC_UNMAPPED_KEY_BASE | 0x00000004)

#define RC_KEY_BACK           (RC_UNMAPPED_KEY_BASE | 0x00000010)
#define RC_KEY_MAIN           (RC_UNMAPPED_KEY_BASE | 0x00000011)
#define RC_KEY_INFO           (RC_UNMAPPED_KEY_BASE | 0x00000012)
#define RC_KEY_QUIT           (RC_UNMAPPED_KEY_BASE | 0x00000013)

#define RC_KEY_POWER          (RC_UNMAPPED_KEY_BASE | 0x00000020)
#define RC_KEY_MUTE           (RC_UNMAPPED_KEY_BASE | 0x00000021)
#define RC_KEY_VOLUME_UP      (RC_UNMAPPED_KEY_BASE | 0x00000022)
#define RC_KEY_VOLUME_DOWN    (RC_UNMAPPED_KEY_BASE | 0x00000023)

#define RC_KEY_PLAY           (RC_UNMAPPED_KEY_BASE | 0x00000030)
#define RC_KEY_PAUSE          (RC_UNMAPPED_KEY_BASE | 0x00000031)
#define RC_KEY_STOP           (RC_UNMAPPED_KEY_BASE | 0x00000032)
#define RC_KEY_RECORD         (RC_UNMAPPED_KEY_BASE | 0x00000033)
#define RC_KEY_FORWARD        (RC_UNMAPPED_KEY_BASE | 0x00000034)
#define RC_KEY_REWIND         (RC_UNMAPPED_KEY_BASE | 0x00000035)
#define RC_KEY_NEXT           (RC_UNMAPPED_KEY_BASE | 0x00000036)
#define RC_KEY_PREV           (RC_UNMAPPED_KEY_BASE | 0x00000037)
#define RC_KEY_PLAYPAUSE      (RC_UNMAPPED_KEY_BASE | 0x00000038)

#endif
