#include <InterfaceDefs.h>
#include <SupportDefs.h>
#include <AppDefs.h>
#include "RcDefs.h"

#include "rckeymap.h"

TS_RC_keymap   gas_keymap[] = 
{
   /* Mapped messages */
   {"0",             B_KEY_DOWN,          0x1b,    B_SHIFT_KEY},
   {"1",             B_KEY_DOWN,          0x12,    B_SHIFT_KEY},
   {"2",             B_KEY_DOWN,          0x13,    B_SHIFT_KEY},
   {"3",             B_KEY_DOWN,          0x14,    B_SHIFT_KEY},
   {"4",             B_KEY_DOWN,          0x15,    B_SHIFT_KEY},
   {"5",             B_KEY_DOWN,          0x16,    B_SHIFT_KEY},
   {"6",             B_KEY_DOWN,          0x17,    B_SHIFT_KEY},
   {"7",             B_KEY_DOWN,          0x18,    B_SHIFT_KEY},
   {"8",             B_KEY_DOWN,          0x19,    B_SHIFT_KEY},
   {"9",             B_KEY_DOWN,          0x1a,    B_SHIFT_KEY},
   
   {"up",            B_KEY_DOWN,          0x57,    0},         /* up arrow       */
   {"down",          B_KEY_DOWN,          0x62,    0},         /* down arrow     */
   {"left",          B_KEY_DOWN,          0x61,    0},         /* left arrow     */
   {"right",         B_KEY_DOWN,          0x63,    0},         /* right arrow    */
   {"ok",            B_KEY_DOWN,          0x5b,    0},         /* keypad enter   */
   
   /* Unmapped messages */
   {"a",             B_UNMAPPED_KEY_DOWN, RC_KEY_A,            0},
   {"b",             B_UNMAPPED_KEY_DOWN, RC_KEY_B,            0},
   {"c",             B_UNMAPPED_KEY_DOWN, RC_KEY_C,            0},
   {"d",             B_UNMAPPED_KEY_DOWN, RC_KEY_D,            0},
   {"e",             B_UNMAPPED_KEY_DOWN, RC_KEY_E,            0},
   
   {"back",          B_UNMAPPED_KEY_DOWN, RC_KEY_BACK,         0},
   {"quit",          B_UNMAPPED_KEY_DOWN, RC_KEY_QUIT,         0},
   {"main",          B_UNMAPPED_KEY_DOWN, RC_KEY_MAIN,         0},
   {"info",          B_UNMAPPED_KEY_DOWN, RC_KEY_INFO,         0},
   
   {"power",         B_UNMAPPED_KEY_DOWN, RC_KEY_POWER,        0},
   {"mute",          B_UNMAPPED_KEY_DOWN, RC_KEY_MUTE,         0},
   {"volume_up",     B_UNMAPPED_KEY_DOWN, RC_KEY_VOLUME_UP,    0},
   {"volume_down",   B_UNMAPPED_KEY_DOWN, RC_KEY_VOLUME_DOWN,  0},
   
   {"playpause",     B_UNMAPPED_KEY_DOWN, RC_KEY_PLAYPAUSE,    0},
   {"play",          B_UNMAPPED_KEY_DOWN, RC_KEY_PLAY,         0},
   {"pause",         B_UNMAPPED_KEY_DOWN, RC_KEY_PAUSE,        0},
   {"stop",          B_UNMAPPED_KEY_DOWN, RC_KEY_STOP,         0},
   {"record",        B_UNMAPPED_KEY_DOWN, RC_KEY_RECORD,       0},
   {"forward",       B_UNMAPPED_KEY_DOWN, RC_KEY_FORWARD,      0},
   {"rewind",        B_UNMAPPED_KEY_DOWN, RC_KEY_REWIND,       0},
   {"next",          B_UNMAPPED_KEY_DOWN, RC_KEY_NEXT,         0},
   {"prev",          B_UNMAPPED_KEY_DOWN, RC_KEY_PREV,         0},

   {NULL,            B_KEY_DOWN,          0x00, 0},   /* end of list  */
};

