#ifndef MODULEGUI_H
#define MODULEGUI_H

#include <View.h>
#include <PopUpMenu.h>
#include <MenuField.h>
#include <MenuItem.h>

#define MODULE_STRING_SIZE 255
#define MODULE_MAX_DRIVER  16
#define MODULE_MAX_MODULE  16

typedef struct
{
   char name[MODULE_STRING_SIZE];
   BMenuItem  *menu;
} TS_Driver;

typedef struct
{
   char        name[MODULE_STRING_SIZE];
   TS_Driver   driver[MODULE_MAX_DRIVER];
} TS_Module;

class ModuleGui
{
   public:
      ModuleGui(BView *pc_ParentView, uint32 i_Top);
      ~ModuleGui(void);
      
      status_t UpdateDriverList(void);
      
      status_t SetModule(char *psz_Module, char *psz_Driver);
      status_t GetModule(char *psz_Module, char *psz_Driver);
      

   private:
      /* methods */
      status_t InitModule(void);

      /* variables */
      BPopUpMenu  *pc_ModuleMenu;
      BMenuField  *pc_ModuleMenuField;
      
      BPopUpMenu  *pc_DriverMenu;
      BMenuField  *pc_DriverMenuField;
      
      TS_Module   *pas_Modules;
      TS_Module   *ps_CurModule;
};

#endif
