#include <Rect.h>
#include <Box.h>
#include <Button.h>
#include <Path.h>

#include "PrefMessages.h"
#include "RemoteGui.h"
RemoteGui::RemoteGui(BView *pc_ParentView, uint32 i_Top)
{
   float i_Width, i_Height;
   BBox *pc_RemoteBox;
   BRect c_ViewRect;
   BButton *pc_AddButton, *pc_DelButton;
   
   pc_RemoteSelect = NULL;
   
   c_ViewRect = pc_ParentView->Bounds();
   c_ViewRect.left += 5;
   c_ViewRect.right -= 5;
   c_ViewRect.top = i_Top + 5;
   c_ViewRect.bottom = i_Top + 160;
   
   pc_RemoteBox = new BBox(c_ViewRect);
   pc_RemoteBox->SetLabel("Remotes");
   pc_ParentView->AddChild(pc_RemoteBox);

   c_ViewRect = pc_RemoteBox->Bounds();
   c_ViewRect.bottom -= 30;
   c_ViewRect.InsetBy(10,15);
   c_ViewRect.right -= B_V_SCROLL_BAR_WIDTH;
   pc_RemoteListView = new BListView(c_ViewRect, "Remote ListVew");

   pc_RemoteScrollView = new BScrollView("Remote ScrollView", pc_RemoteListView, B_FOLLOW_ALL,0,false,true);
   pc_RemoteBox->AddChild(pc_RemoteScrollView);

   c_ViewRect = pc_RemoteBox->Bounds();
   c_ViewRect.InsetBy(10,5);
   c_ViewRect.top = i_Top + 40;
   
   pc_AddButton = new BButton(c_ViewRect,"Add Remote", "Add",
         new BMessage(PREF_MSG_ADD_REMOTE));
   pc_AddButton->GetPreferredSize(&i_Width,&i_Height);
   pc_AddButton->ResizeTo(i_Width,i_Height);
   pc_RemoteBox->AddChild(pc_AddButton);

   pc_DelButton = new BButton(c_ViewRect,"Del Remote", "Del",
         new BMessage(PREF_MSG_DEL_REMOTE));
   pc_DelButton->GetPreferredSize(&i_Width,&i_Height);
   pc_DelButton->ResizeTo(i_Width,i_Height);
   pc_RemoteBox->AddChild(pc_DelButton);
   pc_DelButton->MoveTo(pc_AddButton->Frame().right + 20,c_ViewRect.top);
   return;
}
 
RemoteGui::~RemoteGui(void)
{
   return;
}

status_t RemoteGui::AddRemoteToList(char *sz_Remote)
{
   uint8 i;
   TS_Remote   *ps_Remote;
   
   /* search free entry */
   ps_Remote = NULL;
   for(i=0; i<REMOTE_MAX_REMOTE; i++)
   {
      if(as_Remote[i].item == NULL)
      {
         ps_Remote = &as_Remote[i];
         break;
      }
   }

   if(ps_Remote == NULL)
      return(B_ERROR);
   
   /* fill it */
   strcpy(ps_Remote->long_name, sz_Remote);
   strcpy(ps_Remote->short_name, BPath(sz_Remote).Leaf());
   
   ps_Remote->item = new BStringItem(ps_Remote->short_name);
   pc_RemoteListView->AddItem(ps_Remote->item);

   return(B_OK);
}  

status_t RemoteGui::DelRemoteFromList(char *sz_Remote)
{
   uint8 i;
   TS_Remote   *ps_Remote;
   
   /* search entry */
   ps_Remote = NULL;
   for(i=0; i<REMOTE_MAX_REMOTE; i++)
   {
      if( (as_Remote[i].item != NULL) &&
          (strcmp(as_Remote[i].long_name, sz_Remote) == 0) )
      {
         ps_Remote = &as_Remote[i];
         break;
      }
   }

   if(ps_Remote == NULL)
      return(B_ERROR);
   
   /* remove it */
   pc_RemoteListView->RemoveItem(ps_Remote->item);
   ps_Remote->item = NULL;

   return(B_OK);
}  
      
TS_Remote   *RemoteGui::FindRemoteByItem(BListItem  *pc_Item)
{
   uint8 i;
   TS_Remote   *ps_Remote = NULL;
   
   /* search entry */
   for(i=0; i<REMOTE_MAX_REMOTE; i++)
   {
      if(as_Remote[i].item == pc_Item)
      {
         ps_Remote = &as_Remote[i];
         break;
      }
   }

   return(ps_Remote);
}
   
status_t RemoteGui::AddRemote(char *sz_Remote)
{
   if(sz_Remote[0] == '\0')
   {
      if(pc_RemoteSelect == NULL)
      {
         pc_RemoteSelect = new BFilePanel(B_OPEN_PANEL, NULL, NULL, 0, true,
                                          new BMessage(PREF_MSG_REMOTE_OPEN), 
                                          NULL, true, true);
      }
      pc_RemoteSelect->Show();
   }
   else
   {
      AddRemoteToList(sz_Remote);
      if(pc_RemoteSelect != NULL)
      {
         delete pc_RemoteSelect;
         pc_RemoteSelect = NULL;
      }
   }
   return(B_OK);
}

status_t RemoteGui::DelRemote(char *sz_DeletedRemote)
{
   int32 i_Index;
   BListItem *pc_Item;
   TS_Remote   *ps_Remote;
  
   i_Index = pc_RemoteListView->CurrentSelection(0);
   if(i_Index >= 0 )
   {
      pc_Item = pc_RemoteListView->ItemAt(i_Index);
      ps_Remote = FindRemoteByItem(pc_Item);
      strcpy(sz_DeletedRemote, ps_Remote->long_name);
      if(ps_Remote != NULL)
         return(DelRemoteFromList(ps_Remote->long_name));
      else
         return(B_OK);
   }
}
